//  C DLL t@CłB

#include <windows.h>
#include <vector>

#include <msclr/marshal.h>
#include <msclr/marshal_cppstd.h> 

#include "ls11_mod.h"
#include "LS11DotNet.h"

using namespace std;
using namespace msclr::interop;
using namespace System::Collections::Generic;

using namespace LS11DotNet;


int Ls11::DecodePack(String^ csFileName, ArrayList^ csDstArrayList) {

	//--------------------String^  char* 
	// .netUnicodefilename}`oCgchar *ƂB
	std::string bufFileName = marshal_as<std::string>(csFileName);
	char *szFileName = (char *)bufFileName.c_str();

	vector<vector<byte>> pvecDstDataArray;

	// C++ NativeŃfR[h
	int result = ls11_DecodePack(szFileName, NULL, &pvecDstDataArray);

	//--------------------vector<vector<byte>>  ArrayList^<ArrayList^<Byte>>
	// JœBxȁ` ܂.net̂̓GfB^쐬pƂpȂł
	for ( int iPackedIX=0; iPackedIX < (int)pvecDstDataArray.size(); iPackedIX++ ) {
		// ɓ
		ArrayList^ OneData = gcnew ArrayList();
		for ( int i=0; i<(int)pvecDstDataArray[iPackedIX].size(); i++ ) {
			OneData->Add(System::Byte(pvecDstDataArray[iPackedIX][i]));
		}
		csDstArrayList->Add(OneData);
	}

	return result;
}

int Ls11::EncodePack(String^ csFileName, ArrayList^ csSrcArrayList) {

	//--------------------String^  char* 
	// .netUnicodefilename}`oCgchar *ƂB
	std::string bufFileName = marshal_as<std::string>(csFileName);
	char *szFileName = (char *)bufFileName.c_str();

	//--------------------ArrayList^<ArrayList^<Byte>>  vector<vector<byte>> 
	vector<vector<byte>> pvecDstDataArray;
    for (int iExpandedIX = 0; iExpandedIX < csSrcArrayList->Count; iExpandedIX++)
    {
		vector<byte> pvecOneData;
        ArrayList^ OneData = gcnew ArrayList();
        OneData = static_cast<ArrayList^>(csSrcArrayList[iExpandedIX]);
		for ( int i=0; i<(int)OneData->Count; i++ ) {
			byte b = static_cast<byte>(OneData->default[i]);
			pvecOneData.push_back(b);
		}
		pvecDstDataArray.push_back( pvecOneData );
	}

	// C++ NativeŃfR[h
	int result = ls11_EncodePack(szFileName, NULL, &pvecDstDataArray);
	return result;
}

// P̈oCif[^AӖPʂŕ
int Ls11::SplitData(ArrayList^ csSrcJoinedData, ArrayList^ csDstSplittedData) {

	// CSharpArrayListvector<byte>ɃRs[
	vector<byte> vSrcJoinedData;
	for ( int i=0; i<(int)csSrcJoinedData->Count; i++ ) {
		byte b = static_cast<byte>(csSrcJoinedData->default[i]);
		vSrcJoinedData.push_back(b);
	}

	// 1̃f[^ӖPʂɕ
	vector<vector<byte>> vDstSplittedData;
	ls11_SplitData(vSrcJoinedData, &vDstSplittedData);

	//--------------------vector<vector<byte>>  ArrayList^<ArrayList^<Byte>>
	// JœBxȁ` ܂.net̂̓GfB^쐬pƂpȂł
	for ( int iSplittedIX=0; iSplittedIX < (int)vDstSplittedData.size(); iSplittedIX++ ) {
		// ɓ
		ArrayList^ OneData = gcnew ArrayList();
		for ( int i=0; i<(int)vDstSplittedData[iSplittedIX].size(); i++ ) {
			OneData->Add(System::Byte(vDstSplittedData[iSplittedIX][i]));
		}
		csDstSplittedData->Add(OneData);
	}

	int result = TRUE;
	return TRUE;
}

// ̂ւƖ߂B
int Ls11::JoinData(ArrayList^ csSrcSplittedData, ArrayList^ csDstJoinedData) {

	// CSharpArrayListvector<vector<byte>>ɃRs[
	vector<vector<byte>> vSrcSplittedData;
	// ܂̓Rs[Oɐ킹
	for ( int iSplittedIX=0; iSplittedIX<(int)csSrcSplittedData->Count; iSplittedIX++ ) {
		vector<byte> srcOneData;
        ArrayList^ OneData = gcnew ArrayList();
        OneData = static_cast<ArrayList^>(csSrcSplittedData[iSplittedIX]);
		for ( int i=0; i<(int)OneData->Count; i++ ) {
			byte b = static_cast<byte>(OneData->default[i]);
			srcOneData.push_back(b);
		}
		vSrcSplittedData.push_back( srcOneData );
	}

	vector<byte> vDstJoinedData;

	// ̂ւƖ߂B
	ls11_JoinData(vSrcSplittedData, &vDstJoinedData);

	// vector<byte>ArrayList<Byte>
    ArrayList^ OneData = gcnew ArrayList();
	for ( int i=0; i<(int)vDstJoinedData.size(); i++ ) {
		csDstJoinedData->Add(System::Byte(vDstJoinedData[i]));
	}

	int result = TRUE;
	return TRUE;
}
